; Ŀ
;  Script:  DoQuery                                                        
;  Purpose: This script permits a user to enter the first and last dates   
;  of a date range to query.  If the beginning date is later than the      
;  ending date, an error message is displayed.                             
;                                                                          
;    This script is part of a sample application described in the          
;    October 1993 issue of Paradox Information.  This script was written   
;    by Cary Jensen of Data Works of Houston.                              
;                                                                          
;                                                                          
;    This script is for demonstration purposes only.  No representation    
;    is made concerning the appropriateness of this script for any other   
;    purpose.  If you use this script you agree to hold its author and     
;    Data Works of Houston free from any claim arising out of the use or   
;    misuse of this script.                                                
; ͵
;                              Cary Jensen                                 
;                          Data Works of Houston                           
;                             CIS 76307,1533                               
;                             (713) 359-3311                               
; ͵
; 

;Initialize the variable that will receive the dates.
;This is how to create default values for dialog box accept elements.
BeginDate = TODAY()
EndDate = TODAY()

;Display a dialog box to get the query dates.
SHOWDIALOG "Query Which Dates?"
  @ 6, 23
  HEIGHT 11 WIDTH 31

  LABEL @ 1, 5 "~B~eginning Date"
    FOR "BeginDate"
  ACCEPT @ 2, 6
    WIDTH 15
    "D"
    REQUIRED
    TAG "BeginDate"
    TO BeginDate

  LABEL @ 4, 5 "~E~nding Date"
    FOR "EndDate"
  ACCEPT @ 5, 6
    WIDTH 15
    "D"
    REQUIRED
    TAG "EndDate"
    TO EndDate


  PUSHBUTTON @ 7, 3
    WIDTH 10
    "OK"
    OK
    VALUE "True"
    TAG "OKButton"
    TO Retval

  PUSHBUTTON @ 7, 16
    WIDTH 10
    "Cancel"
    CANCEL
    VALUE "False"
    TAG "CancelButton"
    TO Retval

ENDDIALOG

;Test th
SWITCH
  CASE NOT Retval:
    ;The user canceled the dialog box.
    QUIT
  CASE EndDate < BeginDate:
    QUIT "Error.  Beginning date later than ending date."
  CASE NOT ISTABLE("Clients"):
    ;The table to query does not exist.
    QUIT "Client table not found.  Cannot query."
  OTHERWISE:
    ;Everything OK.  Build the query.
    MENU {Ask} {Clients}
    CHECK
    [First Contact] = ">="+STRVAL(BeginDate)+", <="+STRVAL(EndDate)
    DO_IT!
    IF ISEMPTY("Answer")
      THEN
        CLEARALL
        QUIT "No records in the selected date range."
    ENDIF
    ;Remove the query image from the desktop.
    MOVETO [Clients (Q)->]
    CLEARIMAGE
    ;Following the return command, the Answer table will be the
    ;current table on the desktop.
    MOVETO "Answer"
    RETURN
ENDSWITCH
