; Ŀ
;  Procedure name: GenRep()                                                
;  Purpose: GenRep displays a menu of possible report output destinations. 
;  and then sends the specified report to that destination.                
;                                                                          
;    This script is part of a sample application described in the          
;    October 1993 issue of Paradox Information.  This script was written   
;    by Cary Jensen of Data Works of Houston.                              
;                                                                          
;    This script is for demonstration purposes only.  No representation    
;    is made concerning the appropriateness of this script for any other   
;    purpose.  If you use this script you agree to hold its author and     
;    Data Works of Houston free from any claim arising out of the use or   
;    misuse of this script.                                                
; ͵
;                              Cary Jensen                                 
;                          Data Works of Houston                           
;                             CIS 76307,1533                               
;                             (713) 359-3311                               
; ͵
; 
PROC GenRep(Tabname,RepName)
PRIVATE Choice, TTChoice, CanPrint

Choice = "Printer"

;=================================;
;Verify that the report exists.  Note that the Standard report always exists.
;=================================;
IF NOT RepName = "R"
  THEN
    IF NOT ISFILE(TabName+".R"+STRVAL(RepName))
      THEN
        ERRORBOX("Sorry, the selected report does not exist.")
        RETURN
    ENDIF
ENDIF


WHILE True

  Splash(False)

  SHOWPULLDOWN
    "Printer"    :"Send report to the printer.":"Printer",
    "Screen"     :"Send report to the screen.":"Screen",
    "File"       :"Send report to a file.":"File",
    "Return"     :"Return to the Main menu":"Esc"
  ENDMENU
  
  GETMENUSELECTION TO Choice
  CLEARPULLDOWN
  SHOWPULLDOWN ENDMENU

  IF NOT Retval OR Choice = "Esc"
    THEN
      RETURN
    ELSE
      LOCK TabName PFL
      IF NOT Retval
        THEN
          RETURN False
      ENDIF
  ENDIF

  SWITCH

    CASE Choice = "Printer":
      CanPrint = True
      ;Print only if the printer is ready.
      MESSAGE "Sending report to the printer."
      WHILE NOT PRINTERSTATUS()
        MESSAGE "Your printer is not ready.  Check your printer."
        SHOWMENU
          "Ok":"Ok.  The printer is now ready.",
          "Cancel":"Cancel printing this report."
          TO TTChoice
          IF TTChoice="Ok"
            THEN
              MESSAGE "Sending report to the printer."
              LOOP
            ELSE
              CanPrint = False
              UNLOCK TabName PFL
              MESSAGE ""
              QUITLOOP
          ENDIF
      ENDWHILE
      IF CanPrint
        THEN
          OPEN PRINTER
          REPORT TabName RepName
          CLOSE PRINTER
          MESSAGE ""
          UNLOCK TabName PFL
      ENDIF

    CASE Choice = "Screen":
      MESSAGE "Sending report to screen.  One moment please..."
      MENU {Report} {Output} SELECT TabName SELECT RepName 
      MESSAGE ""
      CLEARPULLDOWN
      PROMPT "Press Ctrl-F8, or select Cancel, to return."
      {Screen}
      PROMPT
      SHOWPULLDOWN ENDMENU
      UNLOCK TabName PFL

    CASE Choice = "File":
      FileName=DIRECTORY()
      WHILE True
        SHOWDIALOG "Print to File"
          @ 8, 6
          HEIGHT 8 WIDTH 68
        
          LABEL @ 1, 5     "~O~utput file name" FOR "OutFile"
          ACCEPT @ 2, 6
            WIDTH 57
            "A57"
            REQUIRED
            TAG "OutFile"
            TO FileName
        
          PUSHBUTTON @ 4, 15
            WIDTH 10
            "OK"
            OK
            VALUE "True"
            TAG "OKButton"
            TO Retval
        
          PUSHBUTTON @ 4, 39
            WIDTH 10
            "Cancel"
            CANCEL
            VALUE "False"
            TAG "CancelButton"
            TO Retval
        ENDDIALOG
        
        IF NOT RETVAL
          THEN
            QUITLOOP
        ENDIF

        IF ISFILE(FileName)
          THEN
            MESSAGE FileName+" already exists.  Re-use?"
            SHOWMENU
              "No":"No.  Do not overwrite "+FileName+".",
              "Yes":"Yes.  Overwrite "+FileName+" with the new file."
              TO TTCHoice
            IF NOT TTChoice="Yes"
              THEN
                LOOP
            ENDIF
        ENDIF
        MENU {Report} {Output} SELECT TabName SELECT RepName {File}
           TYPEIN FileName ENTER
        HoldWindow = WINDOW()
        MESSAGE "Sending report to the file "+FileName+"."
        SWITCH
          CASE ISFILE(FileName) AND MATCH(HoldWindow,"..already exists.."):
            {Replace} QUITLOOP
          CASE NOT HoldWindow = "":
            ERRORBOX(Window()+".  Please re-enter.")
            MENU ESC
            LOOP
          OTHERWISE:
            QUITLOOP
        ENDSWITCH
      ENDWHILE
      UNLOCK TabName PFL
      MESSAGE ""

    OTHERWISE:
      ErrorBox(Choice + " is not a valid menu choice.  Please select again.")
      LOOP

  ENDSWITCH

ENDWHILE
ENDPROC ; --- GenRep(TabName, RepName)
WRITELIB "Paradox" GenRep
RELEASE PROCS GenRep
